require 'mongo'

module MongoClient
  class << self
    # @return Client to work with MongoDb
    attr_accessor :client

    def insert(model, data, id)
      collection = MongoClient.client[model]
      collection.insert_one({ id: id, **data})
    end

    def find(model, id)
      find_all(model, { id: id } )
    end

    def get_all(model)
      collection = MongoClient.client[model]
      collection.find.collect do |match|
        match.delete("_id")
        match
      end
    end

    def find_all(model, query)
      collection = MongoClient.client[model]
      collection.find( query ).collect do |match|
        match.delete("_id")
        match
      end
    end

    def update(model, id, data)
      collection = MongoClient.client[model]
      collection.update_one({ id: id }, { id: id, **data})
    end

    def delete(model, id)
      collection = MongoClient.client[model]
      collection.delete_one({ id: id })
    end
  end
end

MongoClient.client = Mongo::Client.new(
    [ "#{ENV['mongodb']}:27017" ],
    :database => 'api')
